﻿SLASH_LH1 = "/LoHi";
SLASH_LH2 = "/lohi";
local LoHiVersionNumber = "3.8";
local LoHiVersion = "LootHistory v"..LoHiVersionNumber;
local LoHiVersionShort = "(v"..LoHiVersionNumber..")";
local inIni = false;
local lastIni = nil;
local editName = "";
local editItem = "";
local editIdx = -1;
local LoHiMaxWidth = (GetScreenWidth() - 50);
local LoHiMaxHeight = (GetScreenHeight() - 50);
local LoHiMinWidth = (300);
local LoHiMinHeight = (200);
local LoHiFrameSChildContentTable = {};

--begin localization
local L = {};
L["yes"] = "Yes";
L["no"] = "No";
L["reset"] = "Reset Data?";	
L["clear"] = "Reset";
L["report"] = "Report";
L["Log-Options:"] = "Log-Options:";
L["poor"] = "Poor Items";
L["common"] = "Common Items";
L["uncommon"] = "Uncommon Items";
L["rare"] = "Rare Items";
L["epic"] = "Epic Items";
L["legendary"] = "Legendary Items";
L["artifact"] = "Artifact Items";
L["heirloom"] = "Heirloom"
L["solo"] = "Solo";
L["party"] = "Party";
L["raid"] = "Raid";
L["Report"] = "LoHi-Report ";
L["Report2"] = "Last change on ";
L["Report:"] = "Report to:";
L["ChatFrame1"] = "ChatFrame1";
L["/say"] = "/say";
L["/yell"] = "/yell";
L["/party"] = "/party";
L["/raid"] = "/raid";
L["/guild"] = "/guild";
L["/whisper:"] = "/whisper:";
L["General-Options:"] = "General-Options:";
L["lockFrames"] = "Lock Frames";
L["enableMinimapButton"] = "Enable Minimap-Button";
L["lockMinimapButton"] = "Lock Minimap-Button";
L["LDBClick"] = "Left-Click to open "..LoHiVersion.."|nRight-Click to open Blizzard-LootHistory";
L["Help"] = "O = Show Options|n? = Show Help|nX = Close Frame|n|n- Mouseover a row to highlight and to show Item-Tooltip|n- Shift-Click to copy the ItemLink into the Chatframe-EditBox|n- Alt-Click to to edit the owner of selected Item(s)|n|nReport = Report current LoHi|nReset = Reset the current LoHi";
L["tooltip"] = "Show Item-Tolltip";
L["updated"] = "|cffff0000Loothistory updated to Version v"..LoHiVersionNumber..".|r";
L["updated2"] = "|cffff0000The complete LootHistory-Data has been reset, caused by compatibility-reasons.|r";
L["need"] = "N: ";
L["greed"] = "G: ";
L["disenchant"] = "D: ";
L["loot"] = "loot: "; --AddOn needs correct localization to work!!!
L["you"] = "You"; --AddOn needs correct localization to work!!!
if (GetLocale() == "enUS") then
elseif (GetLocale() == "deDE") then
	L["yes"] = "Ja";
	L["no"] = "Nein";
	L["reset"] = "Daten löschen?";	
	L["clear"] = "Löschen";
	L["report"] = "Berichten";
	L["Log-Options:"] = "Log-Optionen:";
	L["poor"] = "Schlechte Gegenstände";
	L["common"] = "Gewöhnliche Gegenstände";
	L["uncommon"] = "Gute Gegenstände";
	L["rare"] = "Rare Gegenstände";
	L["epic"] = "Epische Gegenstände";
	L["legendary"] = "Legendäre Gegenstände";
	L["artifact"] = "Artefakte";
	L["heirloom"] = "Erbstücke"
	L["solo"] = "Solo";
	L["party"] = "Gruppe";
	L["raid"] = "Schlachtzug";
	L["Report"] = "LoHi-Bericht ";
	L["Report2"] = "Letzte Änderung am ";
	L["Report:"] = "Bericht an:";
	L["ChatFrame1"] = "ChatFrame1";
	L["/say"] = "/sagen";
	L["/yell"] = "/schreien";
	L["/party"] = "/gruppe";
	L["/raid"] = "/schlachtzug";
	L["/guild"] = "/gilde";
	L["/whisper:"] = "/flüstern:";
	L["General-Options:"] = "Allgemeine Optionen:";
	L["lockFrames"] = "Fenster sperren";
	L["enableMinimapButton"] = "Minimap-Button anzeigen";
	L["lockMinimapButton"] = "Minimap-Button sperren";
	L["LDBClick"] = "Links-Klicken um "..LoHiVersion.." zu öffnen|nRechts-Klicken um Blizzard-LootHistory zu öffnen";
	L["Help"] = "O = Optionen|n? = Hilfe|nX = Fenster schließen|n|n- Mouseover zum hervorheben der Zeile und um den Item-Tooltip anzuzeigen|n- Shift-Klick um den ItemLink in die Chatframe-EditBox einzufügen|n- Alt-Klick um den Besitzer der / des ausgewählten Items zu ändern|n|nBerichten = LoHi-Bericht erstellen|nReset = LoHi zurücksetzen";
	L["tooltip"] = "Item-Tolltip anzeigen";
	L["updated"] = "|cffff0000Loothistory wurde auf Version v"..LoHiVersionNumber.." geupdated.|r";
	L["updated2"] = "|cffff0000Die komplette LootHistory-Datenbank musste aus Kompatibilitätsgründen zurückgesetzt werden.|r";
	L["need"] = "B: ";
	L["greed"] = "G: ";
	L["disenchant"] = "E: ";
	L["loot"] = "Beute: ";
	L["you"] = "Ihr";
elseif (GetLocale() == "zhCN") then
    L["loot"] = "获得了物品: "; 
    L["you"] = "你";
else
	--[[ 
	feel free to create the following localizations (you can contact me via curse.com):
	"frFR": French
	"koKR": Korean
	"zhCN": Chinese (simplified)
	"zhTW": Chinese (traditional)
	"ruRU": Russian (UI AddOn)
	"esES": Spanish (Spain)
	"esMX": Spanish (Mexico)
	]]--
	print("|cffff0000"..LoHiVersion..": Your WoW-Version isn't compatible. This is caused by localization issues.|r");
end
--end localization

local function LoHitobool(arg1)
	if arg1 == 1 or arg1 == true then	
		return true;
	else
		return false;
	end
end

local function LootHistoryFrameToggle()
	if LootHistoryFrame:IsShown() then
		LootHistoryFrame:Hide();		
	elseif not LootHistoryFrame:IsShown() then
		LootHistoryFrame:Show();
	end
end

local function LoHiToggle()
	if LoHiFrame:IsShown() then
		LoHiFrame:Hide();
		LoHiOptionsFrame:Hide();
	elseif not LoHiFrame:IsShown() then
		LoHiFrame:Show();
	end
end

local function AddToChatFrameEditBox(itemLink)
-- Copy itemLink into ChatFrame
	local x = {SELECTED_DOCK_FRAME:GetChildren()};
	local editbox = x[4];
	if editbox then
		if editbox:HasFocus() then
			editbox:SetText(editbox:GetText()..itemLink);
		else
			editbox:SetFocus(true);
			editbox:SetText(itemLink);
		end
	end
end

local function LoHiSort(db)
-- Sort the userNames of the LoHI alphabetically.
-- return as table.
	local database = {};
	for name, _ in pairs(db) do	
		local i = 1
		local n = #database + 1;
		while i <= n do			
			if i == n then
				tinsert(database, name);
			elseif name <= database[i] then
				tinsert(database, i, name);					
				i = n;			
			end
			i = i + 1;
		end
	end
	return database;
end

local function LoHiSortItemLinks(db)
-- Sort the ItemLinks of the ItemIDs of the LoHi[userName] alphabetically.
-- return as table.
	local database = {};
	for itemLink, _ in pairs(db) do	
		local name1, _, _, _, _, _, _, _, _, _, _ = GetItemInfo(itemLink);
		if name1 then
			local i = 1
			local n = #database + 1;
			while i <= n do			
				if i == n then
					tinsert(database, itemLink);
				else
					local name2, _, _, _, _, _, _, _, _, _, _ = GetItemInfo(database[i]);					
					if name2 then
						if name1 <= name2 then
							tinsert(database, i, itemLink);					
							i = n;
						end
					end
				end
				i = i + 1;
			end
		end
	end
	return database;
end

local function LoHiReport(message)
	if LoHiReportTo["ChatFrame1"] then
		print(message);
	end
	if LoHiReportTo["Say"] then
		SendChatMessage(message, "SAY");
	end
	if LoHiReportTo["Yell"] then
		SendChatMessage(message, "YELL");
	end
	if LoHiReportTo["Party"] then
		if GetNumGroupMembers() > 0 then
			SendChatMessage(message, "PARTY");
		end
	end
	if ((LoHiReportTo["Raid"]) and (GetNumGroupMembers() > 0)) then
		SendChatMessage(message, "RAID");
	end
	if LoHiReportTo["Guild"] then
		local guild = GetGuildInfo("player");		
		if (not(guild == nil)) then
			SendChatMessage(message, "GUILD");
		end
	end
	if LoHiReportTo["Whisper"] then
		local h = LoHiReportFrameWhisperBox:GetText();
		if (not (h == nil)) then
			SendChatMessage(message, "WHISPER", nil, h);
		end
	end
end

local function LoHiReportData()
	if (LoHi and LoHiFrameSChildContentTable[1][0]:IsShown()) then
		local LoHiSortedNames = LoHiSort(LoHi);
		LoHiReport(L["Report"]..LoHiVersionShort..":");
		LoHiReport(L["Report2"]..tostring(LoHiLastChange));
		for _, userName in ipairs(LoHiSortedNames) do
			local LoHiSortedItemLinks = LoHiSortItemLinks(LoHi[userName]);
			LoHiReport(userName..":");
			for _, itemLink in ipairs(LoHiSortedItemLinks) do				
				for j = 1, #LoHi[userName][itemLink] do
					local report = "  "..itemLink;
					local num = LoHi[userName][itemLink][j][1];
					local rollType = LoHi[userName][itemLink][j][2];
					local roll = LoHi[userName][itemLink][j][3];
					if num > 1 then
						report = report.."x"..num;
					end
					if (rollType == LOOT_ROLL_TYPE_NEED) then
						report = report.." ("..L["need"]..roll..")";
					elseif (rollType == LOOT_ROLL_TYPE_GREED) then
						report = report.." ("..L["greed"]..roll..")";
					elseif (rollType == LOOT_ROLL_TYPE_DISENCHANT) then
						report = report.." ("..L["disenchant"]..roll..")";
					end
					LoHiReport(report);
				end
			end
		end		
	end
end

local function LoHiCreateSChild(j)
	local x = #LoHiFrameSChildContentTable;
	if x == 0 then
		local LoHiFrameSChildContent = {};
				
		LoHiFrameSChildContent[0] = CreateFrame("FRAME", nil, LoHiFrameSChild);		
		LoHiFrameSChildContent[0]:SetWidth(LoHiFrameSChild:GetWidth() - 20);
		LoHiFrameSChildContent[0]:SetHeight(15);
		LoHiFrameSChildContent[0]:SetScript("OnEnter", function(self)
												self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"});
												self:SetBackdropColor(0.8,0.8,0.8,0.9);
												end);
		LoHiFrameSChildContent[0]:SetScript("OnLeave", function(self)
												self:SetBackdrop(nil);
												end);
		LoHiFrameSChildContent[0]:SetPoint("TOPLEFT");
		LoHiFrameSChildContent[0]:Show();
		
		LoHiFrameSChildContent[1] = LoHiFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
		LoHiFrameSChildContent[1]:SetTextColor(1, 1, 1, 0.8);	
		LoHiFrameSChildContent[1]:SetPoint("TOPLEFT");
		
		LoHiFrameSChildContent[2] = LoHiFrameSChildContent[0]:CreateTexture(nil, "OVERLAY");
		LoHiFrameSChildContent[2]:SetTexture(nil);
		LoHiFrameSChildContent[2]:SetWidth(15);
		LoHiFrameSChildContent[2]:SetHeight(15);
		LoHiFrameSChildContent[2]:SetPoint("TOPLEFT", LoHiFrameSChildContent[1], "TOPRIGHT", 5, 0);
		
		LoHiFrameSChildContent[3] = LoHiFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
		LoHiFrameSChildContent[3]:SetTextColor(1, 1, 1, 0.8);	
		LoHiFrameSChildContent[3]:SetPoint("TOPLEFT", LoHiFrameSChildContent[2], "TOPRIGHT");

		LoHiFrameSChildContent[0]:Hide();
		
		tinsert(LoHiFrameSChildContentTable, LoHiFrameSChildContent);
	else
		for i = x + 1, j + x do
			local LoHiFrameSChildContent = {};
			
			LoHiFrameSChildContent[0] = CreateFrame("FRAME", nil, LoHiFrameSChild);		
			LoHiFrameSChildContent[0]:SetWidth(LoHiFrameSChild:GetWidth() - 20);
			LoHiFrameSChildContent[0]:SetHeight(15);
			LoHiFrameSChildContent[0]:SetPoint("TOPLEFT", LoHiFrameSChildContentTable[i-1][0], "BOTTOMLEFT");
			LoHiFrameSChildContent[0]:Show();
			
			LoHiFrameSChildContent[1] = LoHiFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
			LoHiFrameSChildContent[1]:SetTextColor(1, 1, 1, 0.8);	
			LoHiFrameSChildContent[1]:SetPoint("TOPLEFT");
			
			LoHiFrameSChildContent[2] = LoHiFrameSChildContent[0]:CreateTexture(nil, "OVERLAY");
			LoHiFrameSChildContent[2]:SetTexture(nil);
			LoHiFrameSChildContent[2]:SetWidth(15);
			LoHiFrameSChildContent[2]:SetHeight(15);
			LoHiFrameSChildContent[2]:SetPoint("TOPLEFT", LoHiFrameSChildContent[1], "TOPRIGHT", 5, 0);
			
			LoHiFrameSChildContent[3] = LoHiFrameSChildContent[0]:CreateFontString(nil, "Artwork", "ChatFontNormal");
			LoHiFrameSChildContent[3]:SetTextColor(1, 1, 1, 0.8);	
			LoHiFrameSChildContent[3]:SetPoint("TOPLEFT", LoHiFrameSChildContent[2], "TOPRIGHT");

			LoHiFrameSChildContent[0]:Hide();
			
			tinsert(LoHiFrameSChildContentTable, LoHiFrameSChildContent);
		end
	end
end

local function LoHiHideSChildFrame(j)
--Hides all SChildFrames, beginning at Position j
	local n = #LoHiFrameSChildContentTable;
	for i = j, n do
		LoHiFrameSChildContentTable[i][0]:Hide();
	end
end

local function LoHiRefreshSChildFrame()
--Refresh the SChildFrame
	local n = #LoHiFrameSChildContentTable;
	local i = 1;
	local LoHiSortedNames = LoHiSort(LoHi);
	for _, userName in ipairs(LoHiSortedNames) do	
		local LoHiSortedItemLinks = LoHiSortItemLinks(LoHi[userName]);		
		if i > n then
			LoHiCreateSChild(1);
		end
		LoHiFrameSChildContentTable[i][1]:SetText(userName..":");
		LoHiFrameSChildContentTable[i][2]:SetTexture(nil);
		LoHiFrameSChildContentTable[i][3]:SetText("");
		LoHiFrameSChildContentTable[i][0]:SetScript("OnEnter", nil);
		LoHiFrameSChildContentTable[i][0]:SetScript("OnLeave", nil);
		LoHiFrameSChildContentTable[i][0]:SetScript("OnMouseUp", nil);
		LoHiFrameSChildContentTable[i][0]:Show();
		i = i + 1;
		for _, itemLink in ipairs(LoHiSortedItemLinks) do			
			for j = 1, #LoHi[userName][itemLink] do
				if i > n then
					LoHiCreateSChild(1);
				end
				local num = LoHi[userName][itemLink][j][1];
				local rollType = LoHi[userName][itemLink][j][2];
				local roll = LoHi[userName][itemLink][j][3];
				if num > 1 then
					LoHiFrameSChildContentTable[i][1]:SetText("    "..itemLink.."x"..num);
					LoHiFrameSChildContentTable[i][2]:SetTexture(nil);
					LoHiFrameSChildContentTable[i][3]:SetText("");
				elseif num == 1 then
					LoHiFrameSChildContentTable[i][1]:SetText("    "..itemLink);
					LoHiFrameSChildContentTable[i][2]:SetTexture(nil);
					LoHiFrameSChildContentTable[i][3]:SetText("");
				end				
				if (rollType == LOOT_ROLL_TYPE_NEED) then
					LoHiFrameSChildContentTable[i][2]:SetTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up");
					LoHiFrameSChildContentTable[i][3]:SetText(roll);
				elseif (rollType == LOOT_ROLL_TYPE_GREED) then
					LoHiFrameSChildContentTable[i][2]:SetTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up");
					LoHiFrameSChildContentTable[i][3]:SetText(roll);
				elseif (rollType == LOOT_ROLL_TYPE_DISENCHANT) then
					LoHiFrameSChildContentTable[i][2]:SetTexture("Interface\\Buttons\\UI-GroupLoot-DE-Up");
					LoHiFrameSChildContentTable[i][3]:SetText(roll);
				elseif (rollType == LOOT_ROLL_TYPE_PASS) then
					LoHiFrameSChildContentTable[i][2]:SetTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up");
				else
					LoHiFrameSChildContentTable[i][2]:SetTexture(nil);
				end								
				LoHiFrameSChildContentTable[i][0]:SetScript("OnEnter", function(self)
													self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"});
													self:SetBackdropColor(0.8,0.8,0.8,0.9);
													if LoHi_Tooltip then
														GameTooltip:SetOwner(self, "ANCHOR_LEFT");
														GameTooltip:SetHyperlink(itemLink);
														GameTooltip:Show();
													end
													end);
				LoHiFrameSChildContentTable[i][0]:SetScript("OnLeave", function(self)
													if LoHi_Tooltip then
														GameTooltip_Hide();
													end
													self:SetBackdrop(nil);
												end);				
				LoHiFrameSChildContentTable[i][0]:SetScript("OnMouseUp", function(self, button)
													if IsShiftKeyDown() then
													--copy into chatframe
														AddToChatFrameEditBox(itemLink);
													elseif IsControlKeyDown() then
													--preview item
														DressUpItemLink(itemLink);
													elseif IsAltKeyDown() then
													--edit
														editName = userName;
														editItem = itemLink;
														editIdx = j;
														if num > 1 then
															LoHiEditFrameItem:SetText(itemLink.."x"..num);
														else
															LoHiEditFrameItem:SetText(itemLink);
														end																									
														LoHiEditFrameOwnerBox:SetText(userName);
														LoHiEditFrame:Show();
														LoHiEditFrameOwnerBox:SetFocus(true);												
													end
												end);
				LoHiFrameSChildContentTable[i][0]:Show();
				i = i + 1;
			end
		end		
	end
	LoHiHideSChildFrame(i);	
	if (LoHiFrameSChildContentTable[1] and LoHiFrameSChildContentTable[1][0] and LoHiFrameSChildContentTable[1][0]:IsShown()) then		
		LoHiFrameShowButton:Enable();		
		LoHiFrameClearButton:Enable();
	else
		LoHiFrameShowButton:Disable();
		LoHiFrameClearButton:Disable();
	end
end

local function ClearLoHi()	
	wipe(LoHi);
	LoHiHideSChildFrame(1);
	LoHiFrameShowButton:Disable();
	LoHiFrameClearButton:Disable();
	LoHiLastChange = date("%d.%m.%y - %H:%M");
end

local function LoHi_tinsert(userName, itemLink, num, rollType, roll)
-- inserts into LoHi
-- print(tostring(userName)..", "..tostring(itemName)..", "..tostring(num)..", "..tostring(rollType)..", "..tostring(roll));
	if (userName and itemLink and num and rollType and roll) then		
		if LoHi[userName] then		
			if LoHi[userName][itemLink] then				
				if rollType == -1 then
					local f = -1;
					for i = 1, #LoHi[userName][itemLink] do
						if LoHi[userName][itemLink][i][2] == -1 then
							f = i;
							i = #LoHi[userName][itemLink] + 1;
						end
					end
					if f > 0 then
						LoHi[userName][itemLink][f][1] = LoHi[userName][itemLink][f][1] + num;
						LoHiLastChange = date("%d.%m.%y - %H:%M");
					else
						tinsert(LoHi[userName][itemLink], {num, rollType, roll});
						LoHiLastChange = date("%d.%m.%y - %H:%M");
					end
				else
					tinsert(LoHi[userName][itemLink], {num, rollType, roll});
					LoHiLastChange = date("%d.%m.%y - %H:%M");
				end
			else
				LoHi[userName][itemLink] = {{num, rollType, roll}};
				LoHiLastChange = date("%d.%m.%y - %H:%M");
			end
		else
			LoHi[userName] = {};
			LoHi[userName][itemLink] = {{num, rollType, roll}};
			LoHiLastChange = date("%d.%m.%y - %H:%M");
		end
	end
end

local function LoHi_CHAT_MSG_LOOT(arg1)
-- parse the chat-message and add the item to the LoHi, if the following conditions are fullfilled.
	local s, _ = string.find(arg1, "%|c");
	local _, e = string.find(arg1, "%]%|h%|r");
	local itemLink = string.sub(arg1, s, e);	
	local _, _, itemRarity, _, _, itemType, _, _, _, _, _ = GetItemInfo(itemLink);
	local inRaid = IsInRaid();
	local inParty = false;
	if GetNumGroupMembers() > 0 then
		inParty = true;
	end
	if (((LoHiLog["Raid"] and inRaid) or 
		(LoHiLog["Party"] and inParty and not inRaid) or
		(LoHiLog["Solo"] and not inParty and not inRaid))
		and 
		(not(itemType == "Money")) 
		and 
		((LoHiItemRarity[0] and itemRarity == 0) or
		(LoHiItemRarity[1] and itemRarity == 1) or
		(LoHiItemRarity[2] and itemRarity == 2) or
		(LoHiItemRarity[3] and itemRarity == 3) or
		(LoHiItemRarity[4] and itemRarity == 4) or
		(LoHiItemRarity[5] and itemRarity == 5) or
		(LoHiItemRarity[6] and itemRarity == 6))) 
	then	
		-- get correct userName:
		-- case 1 = Player
		-- case 2a = Group-Member, same Realm
		-- case 2b = Group-Member, different Realm
		local userName = string.sub(arg1, 0, (string.find(arg1, " ")-1));	
		if userName == L["you"] then
			userName = UnitName("PLAYER");		
		else
			local h = "party"
			if inRaid then
				h = "raid"
			end
			for i = 1, GetNumGroupMembers() do
				local x = h..i;
				local n, r = UnitName(x);
				if userName == n then
					if (not (UnitIsSameServer(x, "PLAYER"))) then		
						if r then
							userName = n.."-"..r;
							i = GetNumGroupMembers() + 1;
						end
					end
				end
			end				
		end
		
		-- parse num from chat-message
		local num = 1;		
		if ((e + 2 ) <= (#arg1 - 1)) then
			num = tonumber(string.sub(arg1, e + 2, #arg1 - 1));
		end		

		-- if possible, get rollType and roll from Blizzard-LootHistory
		local rollType = -1;
		local roll = -1;
		if itemRarity >= 2 then
			for itemIdx = 1, C_LootHistory.GetNumItems() do
				local _, itemLink2, _, _, winnerIdx = C_LootHistory.GetItem(itemIdx);			
				--[[print(" -- "..itemIdx);
				print(tostring(gsub(itemLink, "\124", "\124\124")));
				print(tostring(gsub(itemLink2, "\124", "\124\124")));]]--
				if ((itemLink == itemLink2) and winnerIdx) then					
					local userName2, _, rT, r, _ = C_LootHistory.GetPlayerInfo(itemIdx, winnerIdx);
					if userName == userName2 then
						rollType = rT;
						roll = r;
						itemIdx = C_LootHistory.GetNumItems() + 1;
					end
				end
			end
		end		
		LoHi_tinsert(userName, itemLink, num, rollType, roll);
		LoHiRefreshSChildFrame();
	end
end

function lohitest()
	local LoHiSortedNames = LoHiSort(LoHi);
	for _, userName in ipairs(LoHiSortedNames) do
		local LoHiSortedItemLinks = LoHiSortItemLinks(LoHi[userName]);		
		for _, itemLink in ipairs(LoHiSortedItemLinks) do
			print(userName..": "..itemLink);
			print(tostring(gsub(itemLink, "\124", "\124\124")));
		end
	end
end

SlashCmdList["LH"] = function(args)
	if args == "toggle" then
		LoHiToggle();
	end	
end

local function LoHiOnEvent(event, ...)
	if event == "CHAT_MSG_LOOT" then
		if (... and (strfind(..., L["loot"]))) then
			LoHi_CHAT_MSG_LOOT(...);			
		end	
	elseif event == "PLAYER_ENTERING_WORLD" then
		local inInstance, _ = IsInInstance();
		inInstance = LoHitobool(inInstance);
		local iniName = GetInstanceInfo();		
		if ((inIni == false and inInstance) and not(lastIni == iniName)) then
			inIni = true;
			lastIni = iniName;
			if ((IsInRaid() and LoHiLog["Raid"]) or (UnitInParty("Player") and not IsInRaid() and LoHiLog["Party"]) or (LoHiLog["Solo"] and not IsInRaid() and not UnitInParty("Player"))) then
				LoHiResetFrame:Show();
			end
		elseif (inIni and inInstance == false) then
			inIni = false;			
		end
		LoHiRefreshSChildFrame();
	elseif (event == "ADDON_LOADED" and ... == "LootHistory") then		
		if LoHi == nil then
			LoHi = {};
		end
		if LoHiItemRarity == nil then
			LoHiItemRarity = {};
			LoHiItemRarity[0]=false; --poor (grey)
			LoHiItemRarity[1]=false; --common (white)
			LoHiItemRarity[2]=true; --uncommon (green)
			LoHiItemRarity[3]=true; --rare (blue)
			LoHiItemRarity[4]=true; --epic (purple)
			LoHiItemRarity[5]=true; --legendary (orange)
			LoHiItemRarity[6]=false; --artifact
			--LoHiItemRarity[7]=false; --heirloom
		end
		if LoHiReportTo == nil then
			LoHiReportTo = {};
			LoHiReportTo["ChatFrame1"]=true;
			LoHiReportTo["Say"]=false;
			LoHiReportTo["Yell"]=false;
			LoHiReportTo["Party"]=false;
			LoHiReportTo["Raid"]=false;
			LoHiReportTo["Guild"]=false;
			LoHiReportTo["Whisper"]=false;
		end
		if LoHiLog == nil then 
			LoHiLog = {};
			LoHiLog["Solo"]=false;
			LoHiLog["Party"]=true;
			LoHiLog["Raid"]=true;
		end
		if LoHi_LockFrames == nil then
			LoHi_LockFrames = false;
		end
		if LoHi_LockMinimapButton == nil then
			LoHi_LockMinimapButton = false;
		end
		if LoHi_Frame == nil then
			LoHi_Frame = {};
			LoHi_Frame["width"] = 250;
			LoHi_Frame["height"] = 200;
			LoHi_Frame["point"] = "CENTER";
			LoHi_Frame["x"] = 0;
			LoHi_Frame["y"] = 0;
		end
		if LoHi_MinimapButtonPosition == nil then
			LoHi_MinimapButtonPosition = {};
			LoHi_MinimapButtonPosition["point"] = "TOP";
			LoHi_MinimapButtonPosition["x"] = 0;
			LoHi_MinimapButtonPosition["y"] = 0;
		end
		if LoHi_EnableMinimapButton == nil then
			LoHi_EnableMinimapButton = true;
		end
		if LoHi_LockShowLootFrame == nil then
			LoHi_LockShowLootFrame = false;
		end	
		if LoHi_Tooltip == nil then
			LoHi_Tooltip = true;
		end
		--compatibility fix for older Versions ( < 3.0)
		if LoHi_Version == nil then
			print(L["updated"]);
			print(L["updated2"]);
			ClearLoHi(LoHi);
			LoHi_Version = tonumber(LoHiVersionNumber);
		else
			if LoHi_Version < 3.0 then
				print(L["updated"]);
				print(L["updated2"]);
				ClearLoHi(LoHi);
				LoHi_Version = tonumber(LoHiVersionNumber);
			elseif LoHi_Version < tonumber(LoHiVersionNumber) then
				print(L["updated"]);
				LoHi_Version = tonumber(LoHiVersionNumber);
			elseif LoHi_Version > tonumber(LoHiVersionNumber) then
				print(L["updated"]);
				LoHi_Version = tonumber(LoHiVersionNumber);
			end
		end
		if LoHiLastChange == nil then
			LoHiLastChange = date("%d.%m.%y - %H:%M");
		end
		
		LoHiOptionsCheckButtonLog0:SetChecked(LoHiItemRarity[0]);
		LoHiOptionsCheckButtonLog1:SetChecked(LoHiItemRarity[1]);
		LoHiOptionsCheckButtonLog2:SetChecked(LoHiItemRarity[2]);
		LoHiOptionsCheckButtonLog3:SetChecked(LoHiItemRarity[3]);
		LoHiOptionsCheckButtonLog4:SetChecked(LoHiItemRarity[4]);
		LoHiOptionsCheckButtonLog5:SetChecked(LoHiItemRarity[5]);
		LoHiOptionsCheckButtonLog6:SetChecked(LoHiItemRarity[6]);
		
		LoHiOptionsCheckButtonLogSolo:SetChecked(LoHiLog["Solo"]);
		LoHiOptionsCheckButtonLogParty:SetChecked(LoHiLog["Party"]);
		LoHiOptionsCheckButtonLogRaid:SetChecked(LoHiLog["Raid"]);
		
		LoHiReportFrameCheckButtonChatFrame:SetChecked(LoHiReportTo["ChatFrame1"]);
		LoHiReportFrameCheckButtonSay:SetChecked(LoHiReportTo["Say"]);
		LoHiReportFrameCheckButtonYell:SetChecked(LoHiReportTo["Yell"]);
		LoHiReportFrameCheckButtonParty:SetChecked(LoHiReportTo["Party"]);
		LoHiReportFrameCheckButtonRaid:SetChecked(LoHiReportTo["Raid"]);
		LoHiReportFrameCheckButtonGuild:SetChecked(LoHiReportTo["Guild"]);
		LoHiReportFrameCheckButtonWhisper:SetChecked(LoHiReportTo["Whisper"]);
		
		LoHiOptionsCheckButtonLockFrames:SetChecked(LoHi_LockFrames);
		LoHiOptionsCheckButtonEnableMinimapButton:SetChecked(LoHi_EnableMinimapButton);
		LoHiOptionsCheckButtonLockMinimapButton:SetChecked(LoHi_LockMinimapButton);
		LoHiOptionsCheckButtonTooltip:SetChecked(LoHi_Tooltip);	
		
		LoHiFrame:SetWidth(LoHi_Frame["width"]);
		LoHiFrame:SetHeight(LoHi_Frame["height"]);
		LoHiFrame:SetPoint(LoHi_Frame["point"], LoHi_Frame["x"], LoHi_Frame["y"]);
		
		if not LoHi_LockFrames then		
			LoHiTopFrame:RegisterForDrag("LeftButton");			
		end
				
		LoHiMinimapButton:SetPoint(LoHi_MinimapButtonPosition["point"], Minimap, LoHi_MinimapButtonPosition["x"], LoHi_MinimapButtonPosition["y"]);
		if LoHi_EnableMinimapButton then
			LoHiMinimapButton:Show();
		else
			LoHiMinimapButton:Hide();
		end	
		if not LoHi_LockMinimapButton then		
			LoHiMinimapButton:RegisterForDrag("LeftButton");			
		end
		LoHiRefreshSChildFrame();
	end
end

--LDB
local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
local dataobj = ldb:GetDataObjectByName("LootHistory") or ldb:NewDataObject("LootHistory", {
	type = "data source", icon = [[Interface\AddOns\LootHistory\LootHistoryLDBIcon]], text = "LootHistory",
	OnClick = function(self, button)
                if button == "RightButton" then
					LootHistoryFrameToggle()
				else
					LoHiToggle()
				end
	end,
	OnTooltipShow = function(tip)
		tip:AddLine(L["LDBClick"]);
	end,
})
--end LDB

-- begin UI
local LoHiMinimapButton = CreateFrame("BUTTON", "LoHiMinimapButton", Minimap);
LoHiMinimapButton:SetWidth(31);
LoHiMinimapButton:SetHeight(31);
LoHiMinimapButton:SetFrameStrata("LOW");
LoHiMinimapButton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
LoHiMinimapButton:SetPoint("RIGHT", Minimap, "LEFT");
LoHiMinimapButtonIcon = LoHiMinimapButton:CreateTexture(nil, "BACKGROUND");
LoHiMinimapButtonIcon:SetTexture("Interface\\AddOns\\LootHistory\\LootHistoryIcon");
LoHiMinimapButtonIcon:SetPoint("TOPLEFT", 6, -6);
LoHiMinimapButtonIcon:SetPoint("BOTTOMRIGHT", -6, 6);
LoHiMinimapButtonOverlay = LoHiMinimapButton:CreateTexture(nil, "OVERLAY");
LoHiMinimapButtonOverlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
LoHiMinimapButtonOverlay:SetWidth(53);
LoHiMinimapButtonOverlay:SetHeight(53);
LoHiMinimapButtonOverlay:SetPoint("TOPLEFT");
LoHiMinimapButton:SetMovable(true);
LoHiMinimapButton:EnableMouse(true);
LoHiMinimapButton:SetScript("OnDragStart", function() LoHiMinimapButton:StartMoving() end);
LoHiMinimapButton:SetScript("OnDragStop", function()
													LoHiMinimapButton:StopMovingOrSizing();
													local point, relativeTo, relativePoint, x, y = LoHiMinimapButton:GetPoint();
													LoHi_MinimapButtonPosition["point"] = point;													
													LoHi_MinimapButtonPosition["x"] = x;
													LoHi_MinimapButtonPosition["y"] = y;
												 end);
LoHiMinimapButton:SetScript("OnClick", function(self, button)											
											if button == "RightButton" then
												LootHistoryToggle();
											else
												LoHiToggle();
											end
										end);
LoHiMinimapButton:Hide();

local LoHiResetFrame = CreateFrame("FRAME", "LoHiResetFrame", UIParent);
LoHiResetFrame:SetWidth(160);
LoHiResetFrame:SetHeight(70);
LoHiResetFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiResetFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiResetFrame:EnableMouse(true);
LoHiResetFrame:RegisterForDrag("LeftButton");
LoHiResetFrame:SetMovable(true);
LoHiResetFrame:SetUserPlaced(true);
LoHiResetFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LoHiResetFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LoHiResetFrame:SetPoint("Center", 0, 100);
LoHiResetFrame:Hide();
tinsert(UISpecialFrames, LoHiResetFrame:GetName());

local LoHiResetTopFrame = CreateFrame("FRAME", nil, LoHiResetFrame);
LoHiResetTopFrame:SetWidth(120);
LoHiResetTopFrame:SetHeight(25);
LoHiResetTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiResetTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiResetTopFrame:SetPoint("TOP", 0, 10);
LoHiResetTopFrame:Show();

local LoHiResetFrameText = LoHiResetTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiResetFrameText:SetTextColor(1, 0, 0, 1.0);
LoHiResetFrameText:SetText(LoHiVersion);
LoHiResetFrameText:SetPoint("CENTER");

local LoHiResetFrameText2 = LoHiResetFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiResetFrameText2:SetTextColor(1, 1, 1, 1.0);
LoHiResetFrameText2:SetText(L["reset"]);
LoHiResetFrameText2:SetPoint("CENTER", 0, 5);

local LoHiResetFrameClose = CreateFrame("BUTTON", nil, LoHiResetFrame, "UIPanelButtonTemplate");
LoHiResetFrameClose:SetWidth(15);
LoHiResetFrameClose:SetHeight(15);
LoHiResetFrameClose:SetText("X");
LoHiResetFrameClose:SetPoint("TOPRIGHT", -5, -5);
LoHiResetFrameClose:SetScript("OnClick", function()
											LoHiResetFrame:Hide();											
										   end);
LoHiResetFrameClose:SetAlpha(1);
LoHiResetFrameClose:Show();

local LoHiResetFrameNoButton = CreateFrame("BUTTON", nil, LoHiResetFrame, "UIPanelButtonTemplate");
LoHiResetFrameNoButton:SetWidth(70);
LoHiResetFrameNoButton:SetHeight(20);
LoHiResetFrameNoButton:SetText(L["no"]);
LoHiResetFrameNoButton:SetPoint("BOTTOMRIGHT", -7, 5);
LoHiResetFrameNoButton:SetScript("OnClick", function()
											LoHiResetFrame:Hide();
										   end);
LoHiResetFrameNoButton:SetAlpha(1);
LoHiResetFrameNoButton:Show();

local LoHiResetFrameYesButton = CreateFrame("BUTTON", nil, LoHiResetFrame, "UIPanelButtonTemplate");
LoHiResetFrameYesButton:SetWidth(70);
LoHiResetFrameYesButton:SetHeight(20);
LoHiResetFrameYesButton:SetText(L["yes"]);
LoHiResetFrameYesButton:SetPoint("BOTTOMLEFT", 7, 5);
LoHiResetFrameYesButton:SetScript("OnClick", function()
														ClearLoHi();
														LoHiResetFrame:Hide();
												end);
LoHiResetFrameYesButton:SetAlpha(1);
LoHiResetFrameYesButton:Show();

local LoHiFrame = CreateFrame("FRAME", "LoHiFrame", UIParent);
LoHiFrame:SetFrameStrata("HIGH"); 
LoHiFrame:RegisterEvent("ADDON_LOADED");
LoHiFrame:RegisterEvent("CHAT_MSG_LOOT");
LoHiFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
--LoHiFrame:RegisterEvent("LOOT_ROLLS_COMPLETE");
LoHiFrame:SetScript("OnEvent", function(self, event, ...)
										LoHiOnEvent(event, ...);
										end);
LoHiFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiFrame:EnableMouse(true);
LoHiFrame:SetMovable(true);
LoHiFrame:SetUserPlaced(true);
LoHiFrame:SetScript("OnSizeChanged", function()
												LoHiFrameSChild:SetWidth(LoHiFrame:GetWidth() - 30);
												LoHiSFrame:SetWidth(LoHiFrameSChild:GetWidth() - 18);
												LoHiSFrame:SetHeight(LoHiFrame:GetHeight() - 65);
												LoHiOptionsFrame:SetWidth(LoHiFrame:GetWidth());
												LoHiHelpFrame:SetWidth(LoHiFrame:GetWidth());
												for i = 1 , #LoHiFrameSChildContentTable do
													LoHiFrameSChildContentTable[i][0]:SetWidth(LoHiFrameSChild:GetWidth() - 20);
												end
											end);
LoHiFrame:SetResizable(true);
LoHiFrame:SetMaxResize(LoHiMaxWidth, LoHiMaxHeight);
LoHiFrame:SetMinResize(LoHiMinWidth, LoHiMinHeight);										  
LoHiFrame:Hide();
tinsert(UISpecialFrames, LoHiFrame:GetName());

local LoHiTopFrame = CreateFrame("FRAME", "LoHiTopFrame", LoHiFrame);
LoHiTopFrame:SetWidth(120);
LoHiTopFrame:SetHeight(25);
LoHiTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiTopFrame:SetPoint("TOP", 0, 10);
LoHiTopFrame:EnableMouse(true);
LoHiTopFrame:SetScript("OnDragStart", function()
												LoHiFrame:StartMoving(); 
												LoHiTopFrame:SetBackdropColor(1.0,1.0,1.0,0.9);
											end);
LoHiTopFrame:SetScript("OnDragStop", function()
											LoHiFrame:StopMovingOrSizing();
											local point, relativeTo, relativePoint, x, y = LoHiFrame:GetPoint();
											LoHi_Frame["point"] = point;													
											LoHi_Frame["x"] = x;
											LoHi_Frame["y"] = y;
											LoHi_Frame["width"] = LoHiFrame:GetWidth();
											LoHi_Frame["height"] = LoHiFrame:GetHeight();
											if (not MouseIsOver(LoHiTopFrame)) then
												LoHiTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
											end
										  end);
LoHiTopFrame:SetScript("OnEnter", function()
													LoHiTopFrame:SetBackdropColor(1.0,1.0,1.0,0.9);
												end);
LoHiTopFrame:SetScript("OnLeave", function()
													if (not IsMouseButtonDown("LeftButton")) then
														LoHiTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
													end
												end);										  
LoHiTopFrame:Show();

local LoHiFrameText = LoHiTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiFrameText:SetTextColor(1, 0, 0, 1.0);
LoHiFrameText:SetText(LoHiVersion);
LoHiFrameText:SetPoint("CENTER");

local LoHiFrameOptions = CreateFrame("BUTTON", nil, LoHiFrame, "UIPanelButtonTemplate");
LoHiFrameOptions:SetWidth(15);
LoHiFrameOptions:SetHeight(15);
LoHiFrameOptions:SetText("O");
LoHiFrameOptions:SetPoint("TOPLEFT", 5, -5);
LoHiFrameOptions:SetScript("OnClick", function()
												if LoHiOptionsFrame:IsShown() then
													LoHiOptionsFrame:Hide();													
												elseif not LoHiOptionsFrame:IsShown() then
													LoHiOptionsFrame:Show();
												end											
											 end);
LoHiFrameOptions:SetAlpha(1);
LoHiFrameOptions:Show();

local LoHiFrameClose = CreateFrame("BUTTON", nil, LoHiFrame, "UIPanelButtonTemplate");
LoHiFrameClose:SetWidth(15);
LoHiFrameClose:SetHeight(15);
LoHiFrameClose:SetText("X");
LoHiFrameClose:SetPoint("TOPRIGHT", -5, -5);
LoHiFrameClose:SetScript("OnClick", function()
											LoHiFrame:Hide();
											LoHiOptionsFrame:Hide();
											LoHiHelpFrame:Hide();
										   end);
LoHiFrameClose:SetAlpha(1);
LoHiFrameClose:Show();

local LoHiFrameHelp = CreateFrame("BUTTON", nil, LoHiFrame, "UIPanelButtonTemplate");
LoHiFrameHelp:SetWidth(15);
LoHiFrameHelp:SetHeight(15);
LoHiFrameHelp:SetText("?");
LoHiFrameHelp:SetPoint("RIGHT", LoHiFrameClose, "LEFT", -5, 0);
LoHiFrameHelp:SetScript("OnClick", function()
											if LoHiHelpFrame:IsShown() then
												LoHiHelpFrame:Hide();
											else
												LoHiHelpFrame:Show();
											end
										   end);
LoHiFrameHelp:SetAlpha(1);
LoHiFrameHelp:Show();

local LoHiSFrame = CreateFrame("SCROLLFRAME", "LoHiSFrame", LoHiFrame, "UIPanelScrollFrameTemplate");
local LoHiFrameSChild = CreateFrame("FRAME", "LoHiFrameSChild", LoHiSFrame);
LoHiSFrame:SetScrollChild(LoHiFrameSChild);
LoHiSFrame:SetPoint("TOPLEFT", LoHiFrame, "TOPLEFT", 10, -25);
LoHiSFrame:SetWidth(LoHiFrame:GetWidth() - 48);
LoHiSFrame:SetHeight(LoHiFrame:GetHeight() - 65);
LoHiSFrame:SetHorizontalScroll(0);
LoHiSFrame:SetVerticalScroll(20);
LoHiSFrame:EnableMouse(true);
LoHiSFrame:Show();
LoHiFrameSChild:SetPoint("TOPLEFT");
LoHiFrameSChild:SetWidth(LoHiFrame:GetWidth() - 30);
LoHiFrameSChild:SetHeight(50);
LoHiFrameSChild:Show();

local LoHiFrameClearButton = CreateFrame("BUTTON", "LoHiFrameClearButton", LoHiFrame, "UIPanelButtonTemplate");
LoHiFrameClearButton:SetWidth(105);
LoHiFrameClearButton:SetHeight(20);
LoHiFrameClearButton:SetText(L["clear"]);
LoHiFrameClearButton:SetPoint("BOTTOM", -55, 10);
LoHiFrameClearButton:SetScript("OnClick", function() LoHiResetFrame:Show(); end);
LoHiFrameClearButton:SetAlpha(1);
LoHiFrameClearButton:Show();

local LoHiFrameShowButton = CreateFrame("BUTTON", "LoHiFrameShowButton", LoHiFrame, "UIPanelButtonTemplate");
LoHiFrameShowButton:SetWidth(105);
LoHiFrameShowButton:SetHeight(20);
LoHiFrameShowButton:SetText(L["report"]);
LoHiFrameShowButton:SetPoint("BOTTOM", 55, 10);
LoHiFrameShowButton:SetScript("OnClick", function()if LoHiReportFrame:IsShown() then
													LoHiReportFrame:Hide();													
												elseif not LoHiReportFrame:IsShown() then
													LoHiReportFrame:Show();
												end	
												end);
LoHiFrameShowButton:SetAlpha(1);
LoHiFrameShowButton:Show();

local LoHiFrameResize = CreateFrame("BUTTON", "LoHiFrameResize", LoHiFrame);
LoHiFrameResize:SetWidth(16);
LoHiFrameResize:SetHeight(16);
LoHiFrameResize:SetPoint("BOTTOMRIGHT", LoHiFrame, "BOTTOMRIGHT", -2, 2);
LoHiFrameResize:SetNormalTexture("Interface\\AddOns\\LootHistory\\LootHistoryResizeButton");
LoHiFrameResize:SetHighlightTexture("Interface\\AddOns\\LootHistory\\LootHistoryResizeButton");
LoHiFrameResize:SetScript("OnMouseDown", function()
													LoHiFrame:StartSizing("BOTTOMRIGHT");
												end);
LoHiFrameResize:SetScript("OnMouseUp", function()
												LoHiFrame:StopMovingOrSizing();
												LoHiFrameSChild:SetWidth(LoHiFrame:GetWidth() - 30);
												LoHiSFrame:SetWidth(LoHiFrameSChild:GetWidth() - 18);
												LoHiSFrame:SetHeight(LoHiFrame:GetHeight() - 65);
												local point, _, _, x, y = LoHiFrame:GetPoint();
												LoHi_Frame["point"] = point;													
												LoHi_Frame["x"] = x;
												LoHi_Frame["y"] = y;
												LoHi_Frame["width"] = LoHiFrame:GetWidth();
												LoHi_Frame["height"] = LoHiFrame:GetHeight();
											end);

local LoHiFrameResize2 = CreateFrame("BUTTON", "LoHiFrameResize2", LoHiFrame);
LoHiFrameResize2:SetWidth(16);
LoHiFrameResize2:SetHeight(16);
LoHiFrameResize2:SetPoint("BOTTOMLEFT", LoHiFrame, "BOTTOMLEFT", 2, 2);
LoHiFrameResize2:SetNormalTexture("Interface\\AddOns\\LootHistory\\LootHistoryResizeButton2");
LoHiFrameResize2:SetHighlightTexture("Interface\\AddOns\\LootHistory\\LootHistoryResizeButton2");
LoHiFrameResize2:SetScript("OnMouseDown", function()
													LoHiFrame:StartSizing("BOTTOMLEFT");
												end);
LoHiFrameResize2:SetScript("OnMouseUp", function()
												LoHiFrame:StopMovingOrSizing();
												LoHiFrameSChild:SetWidth(LoHiFrame:GetWidth() - 30);
												LoHiSFrame:SetWidth(LoHiFrameSChild:GetWidth() - 18);
												LoHiSFrame:SetHeight(LoHiFrame:GetHeight() - 65);
												local point, _, _, x, y = LoHiFrame:GetPoint();
												LoHi_Frame["point"] = point;													
												LoHi_Frame["x"] = x;
												LoHi_Frame["y"] = y;
												LoHi_Frame["width"] = LoHiFrame:GetWidth();
												LoHi_Frame["height"] = LoHiFrame:GetHeight();
											end);											

local LoHiOptionsFrame = CreateFrame("FRAME", "LoHiOptionsFrame", UIParent);
LoHiOptionsFrame:SetWidth(LoHiFrame:GetWidth());
LoHiOptionsFrame:SetHeight(280);
LoHiOptionsFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiOptionsFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiOptionsFrame:SetPoint("TOPLEFT", LoHiFrame, "BOTTOMLEFT", 0, 0);
tinsert(UISpecialFrames, LoHiOptionsFrame:GetName());
LoHiOptionsFrame:Hide();

local LoHiOptionsText1 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsText1:SetTextColor(1.0, 0.8, 0, 0.8);
LoHiOptionsText1:SetWidth(175);
LoHiOptionsText1:SetJustifyH("LEFT");
LoHiOptionsText1:SetText(L["Log-Options:"]);
LoHiOptionsText1:SetPoint("TOPLEFT", 5, -5);

local LoHiOptionsLog0 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog0:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog0:SetWidth(175);
LoHiOptionsLog0:SetHeight(15);
LoHiOptionsLog0:SetJustifyH("LEFT");
LoHiOptionsLog0:SetTextColor(GetItemQualityColor(0));
LoHiOptionsLog0:SetText(L["poor"]);
LoHiOptionsLog0:SetPoint("TOP", LoHiOptionsText1, "BOTTOM", 25, -5);

local LoHiOptionsCheckButtonLog0 = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog0", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog0:SetWidth(15);
LoHiOptionsCheckButtonLog0:SetHeight(15);
LoHiOptionsCheckButtonLog0:SetPoint("RIGHT", LoHiOptionsLog0, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog0:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog0:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog0:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog0:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog0:SetScript("OnClick", function() LoHiItemRarity[0] = LoHitobool(LoHiOptionsCheckButtonLog0:GetChecked()); end);
LoHiOptionsCheckButtonLog0:Show();

local LoHiOptionsLog1 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog1:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog1:SetWidth(175);
LoHiOptionsLog1:SetHeight(15);
LoHiOptionsLog1:SetJustifyH("LEFT");
LoHiOptionsLog1:SetTextColor(GetItemQualityColor(1));
LoHiOptionsLog1:SetText(L["common"]);
LoHiOptionsLog1:SetPoint("TOP", LoHiOptionsLog0, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLog1 = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog1", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog1:SetWidth(15);
LoHiOptionsCheckButtonLog1:SetHeight(15);
LoHiOptionsCheckButtonLog1:SetPoint("RIGHT", LoHiOptionsLog1, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog1:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog1:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog1:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog1:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog1:SetScript("OnClick", function() LoHiItemRarity[1] = LoHitobool(LoHiOptionsCheckButtonLog1:GetChecked()); end);
LoHiOptionsCheckButtonLog1:Show();

local LoHiOptionsLog2 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog2:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog2:SetWidth(175);
LoHiOptionsLog2:SetHeight(15);
LoHiOptionsLog2:SetJustifyH("LEFT");
LoHiOptionsLog2:SetTextColor(GetItemQualityColor(2));
LoHiOptionsLog2:SetText(L["uncommon"]);
LoHiOptionsLog2:SetPoint("TOP", LoHiOptionsLog1, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLog2= CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog2", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog2:SetWidth(15);
LoHiOptionsCheckButtonLog2:SetHeight(15);
LoHiOptionsCheckButtonLog2:SetPoint("RIGHT", LoHiOptionsLog2, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog2:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog2:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog2:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog2:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog2:SetScript("OnClick", function() LoHiItemRarity[2] = LoHitobool(LoHiOptionsCheckButtonLog2:GetChecked()); end);
LoHiOptionsCheckButtonLog2:Show();

local LoHiOptionsLog3 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog3:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog3:SetWidth(175);
LoHiOptionsLog3:SetHeight(15);
LoHiOptionsLog3:SetJustifyH("LEFT");
LoHiOptionsLog3:SetTextColor(GetItemQualityColor(3));
LoHiOptionsLog3:SetText(L["rare"]);
LoHiOptionsLog3:SetPoint("TOP", LoHiOptionsLog2, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLog3 = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog3", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog3:SetWidth(15);
LoHiOptionsCheckButtonLog3:SetHeight(15);
LoHiOptionsCheckButtonLog3:SetPoint("RIGHT", LoHiOptionsLog3, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog3:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog3:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog3:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog3:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog3:SetScript("OnClick", function() LoHiItemRarity[3] = LoHitobool(LoHiOptionsCheckButtonLog3:GetChecked()); end);
LoHiOptionsCheckButtonLog3:Show();

local LoHiOptionsLog4 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog4:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog4:SetWidth(175);
LoHiOptionsLog4:SetHeight(15);
LoHiOptionsLog4:SetJustifyH("LEFT");
LoHiOptionsLog4:SetTextColor(GetItemQualityColor(4));
LoHiOptionsLog4:SetText(L["epic"]);
LoHiOptionsLog4:SetPoint("TOP", LoHiOptionsLog3, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLog4 = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog4", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog4:SetWidth(15);
LoHiOptionsCheckButtonLog4:SetHeight(15);
LoHiOptionsCheckButtonLog4:SetPoint("RIGHT", LoHiOptionsLog4, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog4:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog4:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog4:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog4:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog4:SetScript("OnClick", function() LoHiItemRarity[4] = LoHitobool(LoHiOptionsCheckButtonLog4:GetChecked()); end);
LoHiOptionsCheckButtonLog4:Show();

local LoHiOptionsLog5 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog5:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog5:SetWidth(175);
LoHiOptionsLog5:SetHeight(15);
LoHiOptionsLog5:SetJustifyH("LEFT");
LoHiOptionsLog5:SetTextColor(GetItemQualityColor(5));
LoHiOptionsLog5:SetText(L["legendary"]);
LoHiOptionsLog5:SetPoint("TOP", LoHiOptionsLog4, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLog5 = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog5", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog5:SetWidth(15);
LoHiOptionsCheckButtonLog5:SetHeight(15);
LoHiOptionsCheckButtonLog5:SetPoint("RIGHT", LoHiOptionsLog5, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog5:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog5:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog5:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog5:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog5:SetScript("OnClick", function() LoHiItemRarity[5] = LoHitobool(LoHiOptionsCheckButtonLog5:GetChecked()); end);
LoHiOptionsCheckButtonLog5:Show();

local LoHiOptionsLog6 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLog6:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLog6:SetWidth(175);
LoHiOptionsLog6:SetHeight(15);
LoHiOptionsLog6:SetJustifyH("LEFT");
LoHiOptionsLog6:SetTextColor(GetItemQualityColor(7));
LoHiOptionsLog6:SetText(L["artifact"]);
LoHiOptionsLog6:SetPoint("TOP", LoHiOptionsLog5, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLog6 = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLog6", LoHiOptionsFrame);
LoHiOptionsCheckButtonLog6:SetWidth(15);
LoHiOptionsCheckButtonLog6:SetHeight(15);
LoHiOptionsCheckButtonLog6:SetPoint("RIGHT", LoHiOptionsLog6, "LEFT", -5, 0);
LoHiOptionsCheckButtonLog6:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLog6:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLog6:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLog6:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLog6:SetScript("OnClick", function() LoHiItemRarity[6] = LoHitobool(LoHiOptionsCheckButtonLog6:GetChecked()); end);
LoHiOptionsCheckButtonLog6:Show();

local LoHiOptionsLogSolo = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLogSolo:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLogSolo:SetWidth(175);
LoHiOptionsLogSolo:SetHeight(15);
LoHiOptionsLogSolo:SetJustifyH("LEFT");
LoHiOptionsLogSolo:SetText(L["solo"]);
LoHiOptionsLogSolo:SetPoint("TOP", LoHiOptionsLog6, "BOTTOM", 0, -10);

local LoHiOptionsCheckButtonLogSolo = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLogSolo", LoHiOptionsFrame);
LoHiOptionsCheckButtonLogSolo:SetWidth(15);
LoHiOptionsCheckButtonLogSolo:SetHeight(15);
LoHiOptionsCheckButtonLogSolo:SetPoint("RIGHT", LoHiOptionsLogSolo, "LEFT", -5, 0);
LoHiOptionsCheckButtonLogSolo:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLogSolo:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLogSolo:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLogSolo:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLogSolo:SetScript("OnClick", function() LoHiLog["Solo"] = LoHitobool(LoHiOptionsCheckButtonLogSolo:GetChecked()); end);
LoHiOptionsCheckButtonLogSolo:Show();

local LoHiOptionsLogParty = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLogParty:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLogParty:SetWidth(175);
LoHiOptionsLogParty:SetHeight(15);
LoHiOptionsLogParty:SetJustifyH("LEFT");
LoHiOptionsLogParty:SetText(L["party"]);
LoHiOptionsLogParty:SetPoint("TOP", LoHiOptionsLogSolo, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLogParty = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLogParty", LoHiOptionsFrame);
LoHiOptionsCheckButtonLogParty:SetWidth(15);
LoHiOptionsCheckButtonLogParty:SetHeight(15);
LoHiOptionsCheckButtonLogParty:SetPoint("RIGHT", LoHiOptionsLogParty, "LEFT", -5, 0);
LoHiOptionsCheckButtonLogParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLogParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLogParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLogParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLogParty:SetScript("OnClick", function() LoHiLog["Party"] = LoHitobool(LoHiOptionsCheckButtonLogParty:GetChecked()); end);
LoHiOptionsCheckButtonLogParty:Show();

local LoHiOptionsLogRaid = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLogRaid:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLogRaid:SetWidth(175);
LoHiOptionsLogRaid:SetHeight(15);
LoHiOptionsLogRaid:SetJustifyH("LEFT");
LoHiOptionsLogRaid:SetText(L["raid"]);
LoHiOptionsLogRaid:SetPoint("TOP", LoHiOptionsLogParty, "BOTTOM", 0, 0);

local LoHiOptionsCheckButtonLogRaid = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLogRaid", LoHiOptionsFrame);
LoHiOptionsCheckButtonLogRaid:SetWidth(15);
LoHiOptionsCheckButtonLogRaid:SetHeight(15);
LoHiOptionsCheckButtonLogRaid:SetPoint("RIGHT", LoHiOptionsLogRaid, "LEFT", -5, 0);
LoHiOptionsCheckButtonLogRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLogRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLogRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLogRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLogRaid:SetScript("OnClick", function() LoHiLog["Raid"] = LoHitobool(LoHiOptionsCheckButtonLogRaid:GetChecked()); end);
LoHiOptionsCheckButtonLogRaid:Show();

local LoHiOptionsText3 = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsText3:SetTextColor(1.0, 0.8, 0, 0.8);
LoHiOptionsText3:SetWidth(150);
LoHiOptionsText3:SetJustifyH("LEFT");
LoHiOptionsText3:SetText(L["General-Options:"]);
LoHiOptionsText3:SetPoint("TOPLEFT", LoHiOptionsLogRaid, "BOTTOMLEFT", -25, -10);

local LoHiOptionsLockFrames = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLockFrames:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLockFrames:SetWidth(175);
LoHiOptionsLockFrames:SetHeight(15);
LoHiOptionsLockFrames:SetJustifyH("LEFT");
LoHiOptionsLockFrames:SetText(L["lockFrames"]);
LoHiOptionsLockFrames:SetPoint("TOPLEFT", LoHiOptionsText3, "BOTTOMLEFT", 25, -5);

local LoHiOptionsCheckButtonLockFrames = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLockFrames", LoHiOptionsFrame);
LoHiOptionsCheckButtonLockFrames:SetWidth(15);
LoHiOptionsCheckButtonLockFrames:SetHeight(15);
LoHiOptionsCheckButtonLockFrames:SetPoint("RIGHT", LoHiOptionsLockFrames, "LEFT", -5, 0);
LoHiOptionsCheckButtonLockFrames:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLockFrames:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLockFrames:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLockFrames:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLockFrames:SetScript("OnClick", function() 
																LoHi_LockFrames = LoHitobool(LoHiOptionsCheckButtonLockFrames:GetChecked());
																if LoHiOptionsCheckButtonLockFrames:GetChecked() then
																	LoHiFrame:RegisterForDrag("");
																elseif not LoHiOptionsCheckButtonLockFrames:GetChecked() then
																	LoHiFrame:RegisterForDrag("LeftButton");
																end
															 end);
LoHiOptionsCheckButtonLockFrames:Show();

local LoHiOptionsEnableMinimapButton = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsEnableMinimapButton:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsEnableMinimapButton:SetWidth(175);
LoHiOptionsEnableMinimapButton:SetHeight(15);
LoHiOptionsEnableMinimapButton:SetJustifyH("LEFT");
LoHiOptionsEnableMinimapButton:SetText(L["enableMinimapButton"]);
LoHiOptionsEnableMinimapButton:SetPoint("TOPLEFT", LoHiOptionsLockFrames, "BOTTOMLEFT", 0, 0);

local LoHiOptionsCheckButtonEnableMinimapButton = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonEnableMinimapButton", LoHiOptionsFrame);
LoHiOptionsCheckButtonEnableMinimapButton:SetWidth(15);
LoHiOptionsCheckButtonEnableMinimapButton:SetHeight(15);
LoHiOptionsCheckButtonEnableMinimapButton:SetPoint("RIGHT", LoHiOptionsEnableMinimapButton, "LEFT", -5, 0);
LoHiOptionsCheckButtonEnableMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonEnableMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonEnableMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonEnableMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonEnableMinimapButton:SetScript("OnClick", function() 
																		LoHi_EnableMinimapButton = LoHitobool(LoHiOptionsCheckButtonEnableMinimapButton:GetChecked());
																		if LoHiOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			LoHiMinimapButton:Show();
																		elseif not LoHiOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			LoHiMinimapButton:Hide();
																		end
																	  end);
LoHiOptionsCheckButtonEnableMinimapButton:Show();

local LoHiOptionsLockMinimapButton = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsLockMinimapButton:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsLockMinimapButton:SetWidth(175);
LoHiOptionsLockMinimapButton:SetHeight(15);
LoHiOptionsLockMinimapButton:SetJustifyH("LEFT");
LoHiOptionsLockMinimapButton:SetText(L["lockMinimapButton"]);
LoHiOptionsLockMinimapButton:SetPoint("TOPLEFT", LoHiOptionsEnableMinimapButton, "BOTTOMLEFT", 0, 0);

local LoHiOptionsCheckButtonLockMinimapButton = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonLockMinimapButton", LoHiOptionsFrame);
LoHiOptionsCheckButtonLockMinimapButton:SetWidth(15);
LoHiOptionsCheckButtonLockMinimapButton:SetHeight(15);
LoHiOptionsCheckButtonLockMinimapButton:SetPoint("RIGHT", LoHiOptionsLockMinimapButton, "LEFT", -5, 0);
LoHiOptionsCheckButtonLockMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonLockMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonLockMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonLockMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonLockMinimapButton:SetScript("OnClick", function()
																		LoHi_LockMinimapButton = LoHitobool(LoHiOptionsCheckButtonLockMinimapButton:GetChecked());
																		if LoHiOptionsCheckButtonLockMinimapButton:GetChecked() then
																			LoHiMinimapButton:RegisterForDrag(""); 
																		elseif not LoHiOptionsCheckButtonLockMinimapButton:GetChecked() then																			
																			LoHiMinimapButton:RegisterForDrag("LeftButton");
																		end
																	end);
LoHiOptionsCheckButtonLockMinimapButton:Show();

local LoHiOptionsTooltip = LoHiOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiOptionsTooltip:SetTextColor(1, 1, 1, 0.8);
LoHiOptionsTooltip:SetWidth(175);
LoHiOptionsTooltip:SetHeight(15);
LoHiOptionsTooltip:SetJustifyH("LEFT");
LoHiOptionsTooltip:SetText(L["tooltip"]);
LoHiOptionsTooltip:SetPoint("TOPLEFT", LoHiOptionsLockMinimapButton, "BOTTOMLEFT", 0, 0);

local LoHiOptionsCheckButtonTooltip = CreateFrame("CHECKBUTTON", "LoHiOptionsCheckButtonTooltip", LoHiOptionsFrame);
LoHiOptionsCheckButtonTooltip:SetWidth(15);
LoHiOptionsCheckButtonTooltip:SetHeight(15);
LoHiOptionsCheckButtonTooltip:SetPoint("RIGHT", LoHiOptionsTooltip, "LEFT", -5, 0);
LoHiOptionsCheckButtonTooltip:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiOptionsCheckButtonTooltip:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiOptionsCheckButtonTooltip:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiOptionsCheckButtonTooltip:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiOptionsCheckButtonTooltip:SetScript("OnClick", function()
															LoHi_Tooltip = LoHitobool(LoHiOptionsCheckButtonTooltip:GetChecked());
														end);
LoHiOptionsCheckButtonTooltip:Show();

local LoHiReportFrame = CreateFrame("FRAME", "LoHiReportFrame", UIParent);
LoHiReportFrame:SetFrameStrata("HIGH"); 
LoHiReportFrame:SetWidth(200);
LoHiReportFrame:SetHeight(210);
LoHiReportFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiReportFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiReportFrame:SetPoint("CENTER");
LoHiReportFrame:EnableMouse(true);
LoHiReportFrame:RegisterForDrag("LeftButton");
LoHiReportFrame:SetMovable(true);
LoHiReportFrame:SetUserPlaced(true);
LoHiReportFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LoHiReportFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LoHiReportFrame:Hide();
tinsert(UISpecialFrames, LoHiReportFrame:GetName());

local LoHiReportFrameTop = CreateFrame("FRAME", nil, LoHiReportFrame);
LoHiReportFrameTop:SetWidth(120);
LoHiReportFrameTop:SetHeight(25);
LoHiReportFrameTop:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiReportFrameTop:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiReportFrameTop:SetPoint("TOP", 0, 10);
LoHiReportFrameTop:Show();

local LoHiReportFrameText = LoHiReportFrameTop:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameText:SetTextColor(1, 0, 0, 1.0);
LoHiReportFrameText:SetText(L["Report"]);
LoHiReportFrameText:SetPoint("CENTER");

local LoHiReportFrameClose = CreateFrame("BUTTON", nil, LoHiReportFrame, "UIPanelButtonTemplate");
LoHiReportFrameClose:SetWidth(15);
LoHiReportFrameClose:SetHeight(15);
LoHiReportFrameClose:SetText("X");
LoHiReportFrameClose:SetPoint("TOPRIGHT", -5, -5);
LoHiReportFrameClose:SetScript("OnClick", function()
											LoHiReportFrame:Hide();											
										   end);
LoHiReportFrameClose:SetAlpha(1);
LoHiReportFrameClose:Show();

local LoHiReportFrameText = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
LoHiReportFrameText:SetWidth(175);
LoHiReportFrameText:SetJustifyH("LEFT");
LoHiReportFrameText:SetText(L["Report:"]);
LoHiReportFrameText:SetPoint("TOPLEFT", 5, -30);

local LoHiReportFrameChatFrame = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameChatFrame:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameChatFrame:SetWidth(175);
LoHiReportFrameChatFrame:SetHeight(15);
LoHiReportFrameChatFrame:SetJustifyH("LEFT");
LoHiReportFrameChatFrame:SetText(L["ChatFrame1"]);
LoHiReportFrameChatFrame:SetPoint("TOP", LoHiReportFrameText, "BOTTOM", 25, -5);

local LoHiReportFrameCheckButtonChatFrame = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonChatFrame", LoHiReportFrame);
LoHiReportFrameCheckButtonChatFrame:SetWidth(15);
LoHiReportFrameCheckButtonChatFrame:SetHeight(15);
LoHiReportFrameCheckButtonChatFrame:SetPoint("RIGHT", LoHiReportFrameChatFrame, "LEFT", -5, 0);
LoHiReportFrameCheckButtonChatFrame:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonChatFrame:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonChatFrame:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonChatFrame:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiReportFrameCheckButtonChatFrame:SetScript("OnClick", function() LoHiReportTo["ChatFrame1"] = LoHitobool(LoHiReportFrameCheckButtonChatFrame:GetChecked()); end);
LoHiReportFrameCheckButtonChatFrame:Show();

local LoHiReportFrameSay = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameSay:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameSay:SetWidth(175);
LoHiReportFrameSay:SetHeight(15);
LoHiReportFrameSay:SetJustifyH("LEFT");
LoHiReportFrameSay:SetText(L["/say"]);
LoHiReportFrameSay:SetPoint("TOP", LoHiReportFrameChatFrame, "BOTTOM", 0, 0);

local LoHiReportFrameCheckButtonSay = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonSay", LoHiReportFrame);
LoHiReportFrameCheckButtonSay:SetWidth(15);
LoHiReportFrameCheckButtonSay:SetHeight(15);
LoHiReportFrameCheckButtonSay:SetPoint("RIGHT", LoHiReportFrameSay, "LEFT", -5, 0);
LoHiReportFrameCheckButtonSay:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonSay:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonSay:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonSay:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiReportFrameCheckButtonSay:SetScript("OnClick", function() LoHiReportTo["Say"] = LoHitobool(LoHiReportFrameCheckButtonSay:GetChecked()); end);
LoHiReportFrameCheckButtonSay:Show();

local LoHiReportFrameYell = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameYell:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameYell:SetWidth(175);
LoHiReportFrameYell:SetHeight(15);
LoHiReportFrameYell:SetJustifyH("LEFT");
LoHiReportFrameYell:SetText(L["/yell"]);
LoHiReportFrameYell:SetPoint("TOP", LoHiReportFrameSay, "BOTTOM", 0, 0);

local LoHiReportFrameCheckButtonYell = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonYell", LoHiReportFrame);
LoHiReportFrameCheckButtonYell:SetWidth(15);
LoHiReportFrameCheckButtonYell:SetHeight(15);
LoHiReportFrameCheckButtonYell:SetPoint("RIGHT", LoHiReportFrameYell, "LEFT", -5, 0);
LoHiReportFrameCheckButtonYell:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonYell:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonYell:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonYell:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiReportFrameCheckButtonYell:SetScript("OnClick", function() LoHiReportTo["Yell"] = LoHitobool(LoHiReportFrameCheckButtonYell:GetChecked()); end);
LoHiReportFrameCheckButtonYell:Show();

local LoHiReportFrameParty = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameParty:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameParty:SetWidth(175);
LoHiReportFrameParty:SetHeight(15);
LoHiReportFrameParty:SetJustifyH("LEFT");
LoHiReportFrameParty:SetText(L["/party"]);
LoHiReportFrameParty:SetPoint("TOP", LoHiReportFrameYell, "BOTTOM", 0, 0);

local LoHiReportFrameCheckButtonParty = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonParty", LoHiReportFrame);
LoHiReportFrameCheckButtonParty:SetWidth(15);
LoHiReportFrameCheckButtonParty:SetHeight(15);
LoHiReportFrameCheckButtonParty:SetPoint("RIGHT", LoHiReportFrameParty, "LEFT", -5, 0);
LoHiReportFrameCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiReportFrameCheckButtonParty:SetScript("OnClick", function() LoHiReportTo["Party"] = LoHitobool(LoHiReportFrameCheckButtonParty:GetChecked()); end);
LoHiReportFrameCheckButtonParty:Show();

local LoHiReportFrameRaid = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameRaid:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameRaid:SetWidth(175);
LoHiReportFrameRaid:SetHeight(15);
LoHiReportFrameRaid:SetJustifyH("LEFT");
LoHiReportFrameRaid:SetText(L["/raid"]);
LoHiReportFrameRaid:SetPoint("TOP", LoHiReportFrameParty, "BOTTOM", 0, 0);

local LoHiReportFrameCheckButtonRaid = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonRaid", LoHiReportFrame);
LoHiReportFrameCheckButtonRaid:SetWidth(15);
LoHiReportFrameCheckButtonRaid:SetHeight(15);
LoHiReportFrameCheckButtonRaid:SetPoint("RIGHT", LoHiReportFrameRaid, "LEFT", -5, 0);
LoHiReportFrameCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");	
LoHiReportFrameCheckButtonRaid:SetScript("OnClick", function() LoHiReportTo["Raid"] = LoHitobool(LoHiReportFrameCheckButtonRaid:GetChecked()); end);
LoHiReportFrameCheckButtonRaid:Show();

local LoHiReportFrameGuild = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameGuild:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameGuild:SetWidth(175);
LoHiReportFrameGuild:SetHeight(15);
LoHiReportFrameGuild:SetJustifyH("LEFT");
LoHiReportFrameGuild:SetText(L["/guild"]);
LoHiReportFrameGuild:SetPoint("TOP", LoHiReportFrameRaid, "BOTTOM", 0, 0);

local LoHiReportFrameCheckButtonGuild = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonGuild", LoHiReportFrame);
LoHiReportFrameCheckButtonGuild:SetWidth(15);
LoHiReportFrameCheckButtonGuild:SetHeight(15);
LoHiReportFrameCheckButtonGuild:SetPoint("RIGHT", LoHiReportFrameGuild, "LEFT", -5, 0);
LoHiReportFrameCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiReportFrameCheckButtonGuild:SetScript("OnClick", function() LoHiReportTo["Guild"] = LoHitobool(LoHiReportFrameCheckButtonGuild:GetChecked()); end);
LoHiReportFrameCheckButtonGuild:Show();

local LoHiReportFrameWhisper = LoHiReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiReportFrameWhisper:SetTextColor(1, 1, 1, 0.8);
LoHiReportFrameWhisper:SetWidth(100);
LoHiReportFrameWhisper:SetHeight(15);
LoHiReportFrameWhisper:SetJustifyH("LEFT");
LoHiReportFrameWhisper:SetText(L["/whisper:"]);
LoHiReportFrameWhisper:SetPoint("TOPLEFT", LoHiReportFrameGuild, "BOTTOMLEFT");

local LoHiReportFrameCheckButtonWhisper = CreateFrame("CHECKBUTTON", "LoHiReportFrameCheckButtonWhisper", LoHiReportFrame);
LoHiReportFrameCheckButtonWhisper:SetWidth(15);
LoHiReportFrameCheckButtonWhisper:SetHeight(15);
LoHiReportFrameCheckButtonWhisper:SetPoint("RIGHT", LoHiReportFrameWhisper, "LEFT", -5, 0);
LoHiReportFrameCheckButtonWhisper:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LoHiReportFrameCheckButtonWhisper:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LoHiReportFrameCheckButtonWhisper:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LoHiReportFrameCheckButtonWhisper:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LoHiReportFrameCheckButtonWhisper:SetScript("OnClick", function() LoHiReportTo["Whisper"] = LoHitobool(LoHiReportFrameCheckButtonWhisper:GetChecked()); end);
LoHiReportFrameCheckButtonWhisper:Show();

local LoHiReportFrameWhisperBox = CreateFrame("EDITBOX", "LoHiReportFrameWhisperBox", LoHiReportFrame, "InputBoxTemplate")
LoHiReportFrameWhisperBox:SetWidth(90);
LoHiReportFrameWhisperBox:SetHeight(15);
LoHiReportFrameWhisperBox:SetPoint("LEFT", LoHiReportFrameWhisper, "RIGHT", -40, -2);
LoHiReportFrameWhisperBox:SetMaxLetters(12);
LoHiReportFrameWhisperBox:SetScript("OnTabPressed", function()
													local n, r = UnitName("TARGET");
														if not (n == nil) then
														LoHiReportFrameWhisperBox:SetText(n);
													end
												end);

LoHiReportFrameWhisperBox:SetScript("OnEnterPressed", function() LoHiReportFrameWhisperBox:ClearFocus(); end);
LoHiReportFrameWhisperBox:SetScript("OnTextChanged", function()
	local h = LoHiReportFrameWhisperBox:GetText()
	if #h == 1 then
		LoHiReportFrameWhisperBox:SetText(strupper(h));
	elseif #h > 1 then
		local a = strsub(h, 1, 1);
		local b = strsub(h, 2);		
		LoHiReportFrameWhisperBox:SetText(strupper(a)..strlower(b));
	end
	LoHiWhisperBox = LoHiReportFrameWhisperBox:GetText();
end);
LoHiReportFrameWhisperBox:SetAutoFocus(false);
LoHiReportFrameWhisperBox:Show();

local LoHiReportFrameReportButton = CreateFrame("BUTTON", "LoHiReportFrameReportButton", LoHiReportFrame, "UIPanelButtonTemplate");
LoHiReportFrameReportButton:SetWidth(180);
LoHiReportFrameReportButton:SetHeight(30);
LoHiReportFrameReportButton:SetText(L["report"]);
LoHiReportFrameReportButton:SetPoint("BOTTOM", LoHiReportFrame, "BOTTOM", 0, 10);
LoHiReportFrameReportButton:SetScript("OnClick", function()													
													LoHiReportData();													
												end);
LoHiReportFrameReportButton:SetAlpha(1);
LoHiReportFrameReportButton:Show();

local LoHiEditFrame = CreateFrame("FRAME", "LoHiEditFrame", UIParent);
LoHiEditFrame:SetFrameStrata("HIGH"); 
LoHiEditFrame:SetWidth(310);
LoHiEditFrame:SetHeight(85);
LoHiEditFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiEditFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiEditFrame:SetPoint("CENTER");
LoHiEditFrame:EnableMouse(true);
LoHiEditFrame:RegisterForDrag("LeftButton");
LoHiEditFrame:SetMovable(true);
LoHiEditFrame:SetUserPlaced(true);
LoHiEditFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LoHiEditFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LoHiEditFrame:Hide();
tinsert(UISpecialFrames, LoHiEditFrame:GetName());

L["owner"] = "Owner:";
L["item"] = "Item:";
L["edit"] = "Edit";
L["cancel"]= "Cancel"; 

local LoHiEditFrameItemText = LoHiEditFrame:CreateFontString("LoHiEditFrameItemText", "Artwork", "ChatFontNormal");
LoHiEditFrameItemText:SetTextColor(1, 1, 1, 0.8);
LoHiEditFrameItemText:SetWidth(65);
LoHiEditFrameItemText:SetHeight(15);
LoHiEditFrameItemText:SetText(L["item"]);
LoHiEditFrameItemText:SetJustifyH("LEFT");
LoHiEditFrameItemText:SetPoint("TOPLEFT", LoHiEditFrame, "TOPLEFT", 10, -10);
LoHiEditFrameItemText:Show();

local LoHiEditFrameOwnerText = LoHiEditFrame:CreateFontString("LoHiEditFrameOwner", "Artwork", "ChatFontNormal");
LoHiEditFrameOwnerText:SetTextColor(1, 1, 1, 0.8);
LoHiEditFrameOwnerText:SetWidth(65);
LoHiEditFrameOwnerText:SetHeight(15);
LoHiEditFrameOwnerText:SetText(L["owner"]);
LoHiEditFrameOwnerText:SetJustifyH("LEFT");
LoHiEditFrameOwnerText:SetPoint("TOPLEFT", LoHiEditFrameItemText, "BOTTOMLEFT", 0, -5);
LoHiEditFrameOwnerText:Show();

local LoHiEditFrameItem = LoHiEditFrame:CreateFontString("LoHiEditFrameItem", "Artwork", "ChatFontNormal");
LoHiEditFrameItem:SetTextColor(1, 1, 1, 0.8);
LoHiEditFrameItem:SetWidth(225);
LoHiEditFrameItem:SetHeight(15);
LoHiEditFrameItem:SetJustifyH("LEFT");
LoHiEditFrameItem:SetPoint("LEFT", LoHiEditFrameItemText, "RIGHT", 5, 0);
LoHiEditFrameItem:Show();

local LoHiEditFrameOwnerBox = CreateFrame("EDITBOX", "LoHiEditFrameOwnerBox", LoHiEditFrame, "InputBoxTemplate")
LoHiEditFrameOwnerBox:SetWidth(225);
LoHiEditFrameOwnerBox:SetHeight(15);
LoHiEditFrameOwnerBox:SetPoint("LEFT", LoHiEditFrameOwnerText, "RIGHT", 5, 0);
LoHiEditFrameOwnerBox:SetScript("OnEnterPressed", function() LoHiEditFrameEditButton:Click(); end);
LoHiEditFrameOwnerBox:SetAutoFocus(false);
LoHiEditFrameOwnerBox:Show();

local LoHiEditFrameEditButton = CreateFrame("BUTTON", "LoHiEditFrameEditButton", LoHiEditFrame, "UIPanelButtonTemplate");
LoHiEditFrameEditButton:SetWidth(50);
LoHiEditFrameEditButton:SetHeight(25);
LoHiEditFrameEditButton:SetText(L["edit"]);
LoHiEditFrameEditButton:SetPoint("BOTTOM", LoHiEditFrame, "BOTTOM", -55, 5);
LoHiEditFrameEditButton:SetScript("OnClick", function()
													local newName = LoHiEditFrameOwnerBox:GetText();
													if editName ~= newName then
														if #LoHi[editName][editItem] == 1 then
															LoHi_tinsert(newName, editItem, LoHi[editName][editItem][editIdx][1], LoHi[editName][editItem][editIdx][2], LoHi[editName][editItem][editIdx][3]);
															LoHi[editName][editItem] = nil;
															local x = 0;
															for a, _ in pairs (LoHi[editName]) do																
																x = x + 1;
															end
															if x == 0 then
																LoHi[editName] = nil;
															end
														else
															LoHi_tinsert(newName, editItem, LoHi[editName][editItem][editIdx][1], LoHi[editName][editItem][editIdx][2], LoHi[editName][editItem][editIdx][3]);
															tremove(LoHi[editName][editItem], editIdx);
														end
														LoHiRefreshSChildFrame();
													end
													LoHiEditFrame:Hide();													
												end);
LoHiEditFrameEditButton:SetAlpha(1);
LoHiEditFrameEditButton:Show();

local LoHiEditFrameCancelButton = CreateFrame("BUTTON", "LoHiEditFrameCancelButton", LoHiEditFrame, "UIPanelButtonTemplate");
LoHiEditFrameCancelButton:SetWidth(50);
LoHiEditFrameCancelButton:SetHeight(25);
LoHiEditFrameCancelButton:SetText(L["cancel"]);
LoHiEditFrameCancelButton:SetPoint("BOTTOM", LoHiEditFrame, "BOTTOM", 55, 5);
LoHiEditFrameCancelButton:SetScript("OnClick", function() LoHiEditFrame:Hide(); end);
LoHiEditFrameCancelButton:SetAlpha(1);
LoHiEditFrameCancelButton:Show();

local LoHiHelpFrame = CreateFrame("FRAME", "LoHiHelpFrame", UIParent);
LoHiHelpFrame:SetFrameStrata("HIGH"); 
LoHiHelpFrame:SetWidth(LoHiFrame:GetWidth());
LoHiHelpFrame:SetHeight(200);
if (GetLocale() == "deDE") then
	LoHiHelpFrame:SetHeight(215);
end
LoHiHelpFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LoHiHelpFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LoHiHelpFrame:SetPoint("BOTTOM", LoHiFrame, "TOP", 0, 0);
LoHiHelpFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LoHiHelpFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LoHiHelpFrame:Hide();
tinsert(UISpecialFrames, LoHiHelpFrame:GetName());

local LoHiHelpFrameText = LoHiHelpFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LoHiHelpFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
LoHiHelpFrameText:SetWidth(230);
LoHiHelpFrameText:SetJustifyH("LEFT");
LoHiHelpFrameText:SetText(L["Help"]);
LoHiHelpFrameText:SetPoint("TOPLEFT", 5, -10);